unit ChWalpOptions;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, INIFiles, Spin,

  ChwalpDivers;

type
  TOptBox = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    Bevel1: TBevel;
    Label1: TLabel;
    Bevel2: TBevel;
    Label2: TLabel;
    ChBCaches: TCheckBox;
    ChBLancement: TCheckBox;
    ChBAuto: TCheckBox;
    EdDelai: TEdit;
    SpBDelai: TSpinButton;
    Label3: TLabel;
    ChBFinNone: TCheckBox;
    ChangeAutoGBox: TGroupBox;
    HasardGlobalRB: TRadioButton;
    HasardRepSelRB: TRadioButton;
    SuccRepSelRB: TRadioButton;
    SuccRepHasardRB: TRadioButton;
    SuccRepSuccRB: TRadioButton;
    HasardRepHasardRB: TRadioButton;
    HasardRepSuccRB: TRadioButton;
    CompteBBtn: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure ChBAutoClick(Sender: TObject);
    procedure SpBDelaiDownClick(Sender: TObject);
    procedure SpBDelaiUpClick(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure ChoixTechClick(Sender: TObject);
    procedure CompteBBtnClick(Sender: TObject);
  private
    { Private declarations }
    chHT1, ChHT2 : string ;

    INIObj : TINIFile ;
    INIFile : string ;

    OldLancement, OldAuto, OldCaches, OldFinNone : Boolean ;

    { dlai : le champ est le texte de EdDelai }
    OldDelai : integer ;

    FHasardLieu, Oldhl : THasardLieu;
    FHasardTech, Oldht : THasardTech ;
    procedure SetHasardLieu (hl : THasardLieu);
    procedure SetHasardtech (ht : THasardTech);

    procedure ActualiseBoite ;

    procedure SetDelai (const i : integer) ;
    function  GetDelai : integer ;

  public
    { Public declarations }

    procedure LitINI ;
    procedure SauveINI ;

    property OpHasardLieu : THasardLieu read FHasardLieu write SetHasardLieu ;
    property OpHasardTech : THasardTech read FHasardTech write SetHasardTech ;
    property Delai : integer read GetDelai write SetDelai ;
  end;

{ ajout d'option : ajouter proprit adquate, qui modifiera
 les composnats adquats ;
 initialiser dans Formshow, penser au bouton Annulation }


var
  OptBox: TOptBox;


{******************************************************************}
implementation

{$R *.DFM}

uses SysUtils,
     Ut_Dialg, Maths,
     ChWalpMF ;

procedure TOptBox.FormCreate(Sender: TObject);
begin

  OptEtat := oeChargement ;

 { RGHLieu.ItemIndex := 0 ;
  RGHTech.ItemIndex := 1 ;
  { sauvegarde de 2 chanes initialises dans Delphi et
   qui risquent de disparatre }
{  ChHT1 := RGhTech.Items.Strings[1];
  ChHT2 := RGHTech.Items.Strings[2];

  { les case coches : valeur par dfaut dans Delphi }

  { lecture de l'INI }
  LitINI ;

  OptEtat := oeEnAttente ; { pour synchro }

  repeat
  until Mode = mEnAttente ; { attente que l'autre fiche soit OK }
  if ChBLancement.Checked then ChWalpMainForm.BBtnHasardClick (Self);
  ChWalpMainForm.VerifApresopt ;
 end;

procedure TOptBox.LitINI ;
  var Initrep : string ;
      ch : string ;
      d,code : integer ;
  begin
    InitRep := ExtractFilePath (Application.ExeName);
    INIFile := InitRep+'CHWALP.INI';
    INIObj := TINIFile.Create(INIFile);

    with INIObj do begin
      { lecture HAsardLieu }
      ch:= LowerCase(ReadString ('Options', 'HasardLieu', 'RepActif'));
      if ch='repactif' then OpHasardLieu:=hlRepActif ;
      if ch='rephasard' then OpHasardLieu:=hlRepHasard ;
      if ch='repsucc' then OpHasardLieu:=hlRepSucc ;

      { lecture HasardTech}
      ch := Lowercase(readString('Options', 'HasardTech', 'HasardDsRep'));
      if ch='hasarddsrep' then OpHasardTech := htHasardDsRep ;
      if ch='hasardglobal' then OpHasardTech:= htHasardGlobal ;
      if ch='successif' then OpHasardTech:=htSuccessif ;

      { changeemnt au lancement }
      ch:=LowerCase(ReadString('Options', 'AuLancement', 'Non'));
      ChBLancement.Checked := (ch='oui') or (ch='yes') or (ch='true') or (ch='1');

      { changeemnt auto }
      ch:=LowerCase(ReadString('Options', 'Auto', 'Non'));
      ChBAuto.Checked := (ch='oui') or (ch='yes') or (ch='true') or (ch='1');
      { dlai }
      ch := LowerCase(readString('Options', 'Dlai', '60'));
      Val(ch, d, code);
      Delai := d ;

      { sortie Win }
      ch:=LowerCase(ReadString('Options', 'FinNone', 'Non'));
      ChBFinNone.Checked := (ch='oui') or (ch='yes') or (ch='true') or (ch='1');

      { changemnt au lancement }
      ch:=LowerCase(ReadString('Options', 'FichiersCaches', 'Non'));
      ChBCaches.Checked := (ch='oui') or (ch='yes') or (ch='true') or (ch='1');

      {placement au dpart }
      ch:= LowerCase(ReadString('Placement', 'Top', ''));
      Tag := GetSystemMetrics(sm_CYScreen)-ChwalpMainForm.Height-1;
      if ch='' then ChwalpMainForm.Top:=Tag
               else ChwalpMainForm.Top := Min(Tag, StrToInt(ch));

      {placement au dpart 2}
      ch:= LowerCase(ReadString('Placement', 'Left', ''));
      Tag := GetSystemMetrics(sm_CXScreen)-ChwalpMainForm.Width-1;
      if ch='' then ChwalpMainForm.Left:=Tag
               else ChwalpMainForm.Left := Min (Tag, StrToInt(ch));
    end ;
    INIObj.Free ;

  end ;

procedure TOptBox.SauveINI ;
  var ch : string ;
  begin
    INIObj := TINIFile.Create(INIFile);

    with INIObj do begin
      { lecture HAsardLieu }
      if OpHasardLieu=hlrepActif then ch:='RepActif' ;
      if OpHasardLieu=hlRepHasard then ch:='RepHasard';
      if OpHasardLieu=hlRepSucc then ch:='RepSucc' ;
      WriteString ('Options', 'HasardLieu', ch);

      { lecture HasardTech}
      if OpHasardTech = htHasardDsRep then ch:='HasardDsRep' ;
      if OpHasardTech= htHasardGlobal then ch:='HasardGlobal';
      if OpHasardTech=htSuccessif then ch:='Successif';
      WriteString('Options', 'HasardTech',ch);

      { changeemnt au lancement }
      if ChBLancement.Checked then ch:='Oui' else ch:='Non';
      WriteString('Options', 'AuLancement', ch);

      { changeemnt auto }
      if ChBAuto.Checked then ch:='Oui' else ch:='Non' ;
      WriteString('Options', 'Auto', ch);

      { dlai }
      Str(Delai:3,ch);
      WriteString('Options', 'Dlai',ch);

      { sortie }
      if ChBFinNone.Checked then ch:='Oui' else ch:='Non' ;
      WriteString('Options', 'FinNone', ch);

      { fichiers cachs }
      if ChBCaches.Checked then ch:='Oui' else ch:='Non' ;
      WriteString('Options', 'FichiersCaches', ch);

      {placement : top}
      ch:=IntToStr(ChwalpMainForm.Top);
      WriteString ('Placement', 'Top', ch);
      {left}
      ch:=IntToStr(ChwalpMainForm.Left);
      WriteString ('Placement', 'Left', ch);
    end ;
    INIObj.Free ;
  end ;


procedure TOptBox.FormShow(Sender: TObject);
begin
  Oldhl := OpHasardLieu ;
  Oldht := OpHasardtech ;

  OldLancement := ChBLancement.Checked ;
  OldAuto := ChBAuto.Checked ;
  OldDelai := Delai ;
  oldFinNone := ChBFinnone.Checked ;

  OldCaches := ChBCaches.Checked ;

  { (ds)activation du compteur }
  EdDelai.Enabled := ChBAuto.Checked ;
  SpBDelai.Enabled := ChBAuto.Checked ;

end;

procedure TOptBox.CancelBtnClick(Sender: TObject);
begin
  OpHasardLieu := Oldhl ;
  OpHasardTech := Oldht ;
  ChBLancement.Checked := OldLancement ;
  ChBAuto.Checked := OldAuto ;
  Delai := OldDelai ;
  ChBFinNone.Checked := OldFinNone ;
  ChBCaches.Checked := OldCaches ;
end;

procedure TOptBox.ActualiseBoite ;
  begin
    HasardGlobalRB.Checked      := (OPHasardTech=htHasardGlobal);
    {recouvre les 3 cas, quel que soit hl }
    HasardRepHasardRB.Checked   := (OPHasardTech=htHasardDsRep) and (OpHasardLieu=hlRepHasard);
    HasardRepSelRB.Checked        := (OPHasardTech=htHasardDsRep) and (OpHasardLieu=hlRepActif);
    HasardRepSuccRB.Checked       := (OPHasardTech=htHasardDsRep) and (OpHasardLieu=hlRepSucc);
    SuccRepSelRB.Checked          := (OPHasardTech=htSuccessif) and (OpHasardLieu=hlRepActif);
    SuccRepHasardRB.Checked       := (OPHasardTech=htSuccessif) and (OpHasardLieu=hlRepHasard);
    SuccRepSuccRB.Checked         := (OPHasardTech=htSuccessif) and (OpHasardLieu=hlRepSucc);
  end  ;

procedure TOptBox.SetHasardLieu (hl : THasardLieu);
  begin

    FHasardLieu := hl ;

    ActualiseBoite ;

  end ;

procedure TOptBox.SetHasardTech (ht : THasardtech);
  begin

    FHasardTech := ht ;

    ActualiseBoite ;

  end ;

procedure TOptBox.ChBAutoClick(Sender: TObject);
begin
   { (ds)activation du compteur }
  EdDelai.Enabled := ChBAuto.Checked ;
  SpBDelai.Enabled := ChBAuto.Checked ;
end;

procedure TOptBox.SetDelai (const i : integer) ;
  var d : integer ;
      ch :string ;
  begin
    d := i;
    if d<0 then d := 1 ;
    if d>360 then d:=360 ;

    { sauvegarde dans le champ }
    Str(d:3, ch) ;
    EdDelai.Text:= ch ;
  end ;

function  TOptBox.GetDelai : integer ;
  var d, code : integer ;
  begin
    Val(EdDelai.Text, d, code) ;
    if (d<0) or (d>360) then exclambox ('Valeur aberrante dans EdDelai !');
    if d<0 then d := 1;
    if d>360 then d:=360 ;
    result := d ;
  end ;

procedure TOptBox.SpBDelaiDownClick(Sender: TObject);
begin
  case Delai of
    1..10 :  Delai := Delai-1 ;
    11..30 : Delai := Delai-5 ;
    31..360 : Delai := Delai-10 ;
  end;
end;

procedure TOptBox.SpBDelaiUpClick(Sender: TObject);
begin
  case Delai of
    0..9 : Delai := Delai+1 ;
    10..29 : Delai := Delai+5 ;
    30..359 : Delai := Delai+10 ;
  end ;
end;

procedure TOptBox.OKBtnClick(Sender: TObject);
begin
  SauveINI ;
end;

procedure TOptBox.ChoixTechClick(Sender: TObject);
begin
  if HasardGlobalRB.Checked then
    OpHasardTech := htHasardGlobal 
  else
  if HasardRepHasardRB.Checked then begin
    OpHasardTech := htHasardDsRep;
    OpHasardlieu := hlRepHasard;
  end else
  if HasardRepSuccRB.Checked then begin
    OpHasardTech := htHasardDsRep;
    OpHasardlieu := hlRepSucc;
  end else
  if HasardRepSelRB.Checked then begin
    OpHasardTech := htHasardDsRep;
    OpHasardlieu := hlRepActif;
  end else
  if SuccRepSelRB.Checked then begin
    OpHasardTech := htSuccessif;
    OpHasardlieu := hlRepActif;
  end else
  if SuccRephasardRB.Checked then begin
    OpHasardTech := htSuccessif;
    OpHasardlieu := hlRephasard;
  end else
  if SuccRepSuccRB.Checked then begin
    OpHasardTech := htSuccessif;
    OpHasardlieu := hlRepSucc;
  end else
    YesBox ('Ppin dans ChoixTechClick : OpHasardLieu et Tech non affects');
  
end;

procedure TOptBox.CompteBBtnClick(Sender: TObject);
var i : integer ;
    orig : integer ;
begin
  with ChwalpMainForm do begin
    orig:= DirListeBox.Itemindex;
    i:=0;
    Chwalpmainform.NbTotBMPs:=0;
    repeat
      if VerifSelectRep(i) then begin
        NbBMPs[i]:= FichListeBox.Items.Count;
        NbtotBMPs:=NbtotBMPs+NBBMPs[i];
        Inc(i);
      end
    until i>=DirListeBox.Items.Count ;
    VerifSelectRep(orig);
    IntBox (' Nombre de papiers peints : ', NbtotBMPs);
  end ;
end;

end.
